/*
win-x-move - easier window move/resize for ms windows.
Copyright (C) 2007 John Tsiombikas <nuclear@siggraph.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#include <windows.h>
#include "gui.h"

int set_hook(void);
void remove_hook(void);
extern int hook_enabled;

static int checkbox_state = 1;

long CALLBACK win_proc(HWND win, unsigned int msg, unsigned int wparam, long lparam) {
	switch(msg) {
	case WM_CLOSE:
		DestroyWindow(win);
		PostQuitMessage(0);
		return 0;

	case WM_COMMAND:
		if((HWND)lparam == bn_ok) {
			if(checkbox_state) {
				set_hook();
			} else {
				remove_hook();
			}
			trayfied = !trayfied;
			tray(trayfied);
		} else if((HWND)lparam == bn_cancel) {
			checkbox_state = hook_enabled;
			SendMessage(chk_enable, BM_SETCHECK, checkbox_state ? BST_CHECKED : BST_UNCHECKED, 0);
			trayfied = !trayfied;
			tray(trayfied);
		} else if((HWND)lparam == chk_enable) {
			checkbox_state = !checkbox_state;
		} else if((HWND)lparam == bn_quit) {
			remove_hook();
			DestroyWindow(win);
			PostQuitMessage(0);
		}
		return 0;

	case WM_USER:
		if(lparam == WM_LBUTTONUP) {
			trayfied = !trayfied;
			tray(trayfied);
		}
		return 0;

	default:
		break;
	}

	return DefWindowProc(win, msg, wparam, lparam);
}
